#include <string>
#include <ctype.h>      // declares tolower, isalpha
#include <fstream>
#include <map>

using namespace std;

typedef map< string, int, less< string > > FrequencyMap;


int main()
{
   const string INPUT_PROMPT =
         "Please enter the name of the input file: ";

   const string OUTPUT_PROMPT =
         "Please enter the name of the output file: ";

   const string CLOSE_WINDOW_PROMPT =
         "Please press the Enter key to close this output window.";

   FrequencyMap frequencies;
   FrequencyMap::iterator itr;

   string in_file_name,
          out_file_name,
          word;
   ifstream in_file;
   ofstream out_file;

   cout << INPUT_PROMPT << endl;
   cin >> in_file_name;
   in_file.open( in_file_name.c_str(), ios::in );

   cout << endl << OUTPUT_PROMPT << endl;
   cin >> out_file_name;
   out_file.open( out_file_name.c_str(), ios::out );

   while( in_file >> word )
   {
      // Make word lower case:
      string temp;
      for (unsigned i = 0; i < word.length(); i++)
          temp += tolower(word [i]);
      word = temp;
      
      if( !isalpha( word[ word.length() - 1 ] ) )
         word = word.substr( 0, word.length() - 1 );
      if( frequencies.find ( word ) == frequencies.end() )
         frequencies[ word ] = 1;
      else
         frequencies[ word ]++;
   } // while

   for( itr = frequencies.begin(); itr != frequencies.end(); itr++ )
      out_file << (*itr).first << ", " << (*itr).second << endl;

   cout << endl << endl << CLOSE_WINDOW_PROMPT;
   cin.get();
   return 0;
} // main

