#include <fstream>  // declares open and >> for files
#include <string>   // declares string class
#include <function>
#include "avl.h"    // declares AVLTree class

using namespace std;

class SpellCheck
{
   public:

        // Postcondition: The words in the dictionary file have been
        //                read in. The worstTime(n) is O(n log n),
        //                where n is the number of words in the
        //                dictionary file.
        void readDictionaryFile();


        // Postcondition: The words in the document file have been read in. The
        //                worstTime(k) is O(k log m), where k is the number of words
        //                in the document file.

        void readDocumentFile();

        // Postcondition: Each word that is in the document but not in the dictionary has
        //                been printed. The worstTime(k, n) is O(k log n), where k is
        //                the number of words in the document file and n is the number
        //                of words in the dictionary file.
        void compare();

   protected:
        AVLTree< string, less< string > > dictionary,
                                          words;

}; // SpellCheck
